//---------------------------------------------------------------------------

#ifndef p11FunctionsH
#define p11FunctionsH

#include <windows.h>
#include "cryptoki.h"
//---------------------------------------------------------------------------

void printBytes(CK_BYTE_PTR pBytes, DWORD dLenBytes);

void printSignature(CK_BYTE_PTR pBytes, DWORD dLenBytes);

CK_FUNCTION_LIST_PTR LoadP11(char* LibName);

CK_SLOT_ID selectSlot(CK_FUNCTION_LIST_PTR p11);

CK_SESSION_HANDLE startLogInSession(CK_FUNCTION_LIST_PTR p11, CK_SLOT_ID SlotID);

CK_OBJECT_HANDLE selectCertificate(CK_FUNCTION_LIST_PTR p11, CK_SESSION_HANDLE hSession);

CK_OBJECT_HANDLE selectPrivateKeyByCertificate(CK_FUNCTION_LIST_PTR p11, CK_SESSION_HANDLE hSession, CK_OBJECT_HANDLE Certificate);

CK_RV signData(CK_FUNCTION_LIST_PTR p11, CK_SESSION_HANDLE hSession, CK_OBJECT_HANDLE hKey, unsigned char* pData, DWORD* dLenData);

CK_RV cleanUp(CK_FUNCTION_LIST_PTR p11, CK_SESSION_HANDLE hSession);
#endif
